import time

"""
ACTIVITY 1:
Look at the fib() and time_fib() functions
time_fib returns the nth fibonacci number, but also prints how long the function call took
"""
def fib(n):
    """
    Return the nth fibonacci number
    
    Arguments:
        n (int): the fibonacci number to compute

    Returns:
        int: the nth fibonacci number
    """
    if n == 0 or n == 1:
        return n
    else:
        return fib(n - 1) + fib(n - 2)
    
def time_fib(n):
    """
    Return the nth fibonacci number and also prints how long the function call took
    
    Arguments:
        n (int): the fibonacci number to compute

    Returns:
        int: the nth fibonacci number
    """
    begin = time.process_time()
    number = fib(n)
    end = time.process_time()
    time_elapsed = end - begin # measured in units of seconds
    print("The function call fib(" + str(n) + ") took " + str(time_elapsed) + " seconds")
    return number

"""
ACTIVITY 2:
Take notes on how long it takes to compute fib(n) for several small values of n.
For example, you could choose n ranging between 20 and 25.
You should take these notes as comments in your script file. Take notes here:

n = ??, seconds = ??
n = ??, seconds = ??
n = ??, seconds = ??
n = ??, seconds = ??
n = ??, seconds = ??


Do you notice any patterns?
Approximately how much more time does it take to do time_fib(25) than it does to do time_fib(24)?


"""


"""
ACTIVITY 3:
Now that we've learned something about the time our function takes to execute, let's see if we can
figure out these results. Why does computing just one Fibonacci number take so much longer than
computing the one before it? 

Suppose that I do fib(1). How many times in total will the fib() function be called?
What about if I do fib(2)? What about fib(3)?
Write down your reasoning here:

fib(1): ?? calls
fib(2): ?? calls
fib(3): ?? calls

"""

"""
ACTIVITY 4:
Add an argument to fib called verbose. That is, your function definition should now look like this: 

def fib(n, verbose):
    # your code here


If verbose is True, then print a simple message. Your message could just be a "-" or anything else.
Make sure that you modify the recursive calls to your function so that they also accept the verbose
argument. 

Once you've done this, call fib a few times with *very small* values of n to see how many times the
function gets called in total. Here's the code that I suggest you run: 


n = 1
print("n = " + str(n))
print("-----")
fib(n, True)
n = 2
print("n = " + str(n))
print("-----")
fib(n, True)
n = 3
print("n = " + str(n))
print("-----")
fib(n, True)
n = 4
print("n = " + str(n))
print("-----")
fib(n, True)


It's fine to copy and paste this code from the comment if you want to

By counting the number of messages printed, see if you can find the pattern in how many times the
function is called. Can you relate this to your findings about the amount of time needed to execute
the function? 

"""
